/*
 * Utility.java - A set of utility functions.
 * Copyright (C) 2000 Balaji Srinivasan
 * sbalaji@email.com
 * http://www.sbalaji.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
 
import java.io.*;
import java.net.*;
import java.util.*;

public class Utility
{

	public static void main(String argc [])
	{
		
		String cPageData = "<b><b face=Verdana><b>One</b></b></b><b>Two</b><b>Three</b><b>Four</b>";
		
		String cData;

		System.out.println(removeAllTags("Bala <b>is</b> </font> a nice boy."));

/*
		int i=0;
		while (!((cData = getTaggedDataFromBegin(cPageData, "<b>", "</b>", "<b", i)).equals("")))
		{
			System.out.println("Data:" + cData);
			i++;
		}
		
*/		
		//System.out.println("Data:[" + getOccurances(cPageData, "<b", 0) + "]");
		
		//System.out.println("Data:[" + getTaggedDataFromBegin(cData, "<b>", "</b>", 1) + "]");
		
	}

	public static String getRemotePageData(String cPageUrl)
	{
		try
		{
			
			String cPageData = "";
	
			URL url = new URL(cPageUrl);
			InputStream in = url.openStream();
			Reader r = new BufferedReader(new InputStreamReader(in));
			StreamTokenizer st = new StreamTokenizer(r);
	
			int l;
	
			st.whitespaceChars(32,32);
			st.wordChars(32,126);
	
			while(((l = st.nextToken()) != StreamTokenizer.TT_EOF))
			{
				cPageData += st.sval;
			}
			
			return cPageData;
		
		}
		catch (Exception ex)
		{
			System.out.println(ex);	
			return "";
		}
		
	}

	
	/**
	This function will return the data within 2 tags.
	If the first tag is not found, it will return data from beginning of sreach string till second tag.
	If the second tag is not found, it will return data from end of first tag till end of string.
	If both are not found, it will return the Search string, as is.
	e.g. getTaggedData("<test>somedata</test>","<test>","</test>") sould return "somedata"
	*/	
	public static String getTaggedData(String cData, String cStartTag, String cEndTag)
	{
		StringBuffer sbTmpString = new StringBuffer();;
		return getTaggedData(cData, cStartTag, cEndTag, sbTmpString);
	
	}

	public static String getTaggedData(String cData, String cStartTag, String cEndTag, StringBuffer sbRemainingString)
	{
		int iStartOfStartTag, iEndOfStartTag, iStartOfEndTag;

		String cReturnString = cData; //Initialise
		
		iStartOfStartTag = cData.indexOf(cStartTag);
		
		if (iStartOfStartTag != -1)
		{
			//String was found.
			iEndOfStartTag = iStartOfStartTag + cStartTag.length();
		}
		else
		{
			iEndOfStartTag = 0;
		}
		
		iStartOfEndTag = cData.lastIndexOf(cEndTag);

		if (iStartOfEndTag != -1)
		{
			//String was found.
			cReturnString = cData.substring(iEndOfStartTag, iStartOfEndTag);
		}
		else
		{
			cReturnString = cData.substring(iEndOfStartTag);
		}

		if (iStartOfStartTag == -1 || iStartOfEndTag == -1)
		{
			sbRemainingString.append(cData);
		}
		else
		{
			sbRemainingString.append(cData.substring(0,iStartOfStartTag));
			sbRemainingString.append(cData.substring(iStartOfEndTag + cEndTag.length())); 
		}
		return cReturnString;
	}


	/**
	This function will return the data within 2 tags.
	If the first tag is not found, it will return data from beginning of sreach string till second tag.
	If the second tag is not found, it will return data from end of first tag till end of string.
	If both are not found, it will return the Search string, as is.
	e.g. getTaggedData("<test>somedata</test>","<test>","</test>") sould return "somedata"
	*/	
	public static String getTaggedDataFromBegin(String cData, String cStartTag, String cEndTag, String cTagName, int iOccurance)
	{
		int iStartOfStartTag=0, iEndOfStartTag=0, iStartOfEndTag=0;

		String cReturnString = ""; //Initialise
		
		
		for (int iCounter=0; iCounter<=iOccurance; iCounter++)
		{
			cReturnString = "";
		
		
			iStartOfStartTag = cData.indexOf(cStartTag);
			
			if (iStartOfStartTag != -1)
			{
				//String was found.
				iEndOfStartTag = iStartOfStartTag + cStartTag.length();
			}
			else
			{
				iEndOfStartTag = 0;
			}
			
			boolean bIsValidEndTag = true;
			int i = iEndOfStartTag;
			String cTmpString = "";

			while (bIsValidEndTag)
			{
				iStartOfEndTag = cData.indexOf(cEndTag, i);

				//Now validate if this *is* the end tag...
				
				if (iStartOfEndTag != -1)
				{
					//String was found.
					cTmpString = cData.substring(iEndOfStartTag, iStartOfEndTag);
				}
				else
				{
					cTmpString = cData.substring(iEndOfStartTag);
				}

				
				int iNoOfStartTags = getOccurances(cTmpString, cTagName, 0);
				int iNoOfEndTags = getOccurances(cTmpString, cEndTag, 0);
				
				if (iNoOfStartTags == iNoOfEndTags)
				{
					break;
				}
				
				i = iStartOfEndTag + cEndTag.length();
				
			}			
	
			cReturnString = cTmpString;

			if (iStartOfStartTag == -1 || iStartOfEndTag == -1)
			{
				cReturnString = "";
				break;
			}
			
			cData = cData.substring(iStartOfEndTag + cEndTag.length());
		}		
		return cReturnString;
	}


    /**
     * Replaces all occurences of cFind in cOriginal with cReplace.
     */
    public static String replace(String cOriginal,
                                 String cFind, String cReplace)
    {
        return replace(cOriginal, cFind, cReplace, 0);
    }

    /**
     * Replaces all occurences of cFind in cOriginal with cReplace.
     *
     * @param iStartIndex The iStartIndex gives the position in
     *                    cOriginal where the replace procedure
     *                    should start.
     */
    public static String replace(String cOriginal,
                                 String cFind, String cReplace,
                                 int iStartIndex)
    {

        if (cReplace == null) {
            return "";
        }

        if (cFind == null) {
            return "";
        }

        if (cOriginal == null) {
            return "";
        }

        StringBuffer sbRetVal = new StringBuffer
            ( cOriginal.length() );
        int copyIndex = 0;

        int lengthOld = cFind.length();
        int index = iStartIndex;
        while( true ) {

            index = cOriginal.indexOf(cFind, index);
            if ( index == -1 ) {
                break;
            }
            sbRetVal.append( cOriginal.substring
                             ( copyIndex, index ) );
            sbRetVal.append( cReplace );
            index += lengthOld;
            copyIndex = index;
        }

        sbRetVal.append( cOriginal.substring( copyIndex, cOriginal.length() ) );
        
        return sbRetVal.toString();
    }

    public static int getOccurances(String cOriginal,
                                 String cFind,
                                 int iStartIndex)
    {

        if (cFind == null) {
            return 0;
        }

        if (cOriginal == null) {
            return 0;
        }

        //StringBuffer sbRetVal = new StringBuffer
        //    ( cOriginal.length() );
        //int copyIndex = 0;
        
        int iOccurances = 0;

        int lengthOld = cFind.length();
        
        //cOriginal = cOriginal.subString(0,iEndIndex);
        
        int index = iStartIndex;
        while( true ) {

            index = cOriginal.indexOf(cFind, index);
            if ( index == -1 ) {
                break;
            }
//            sbRetVal.append( cOriginal.substring
//                             ( copyIndex, index ) );
            //sbRetVal.append( cReplace );
            index += cFind.length();
//            copyIndex = index;
            
            iOccurances ++;
        }

//        sbRetVal.append( cOriginal.substring( copyIndex, cOriginal.length() ) );
        
        //return sbRetVal.toString();
        return iOccurances;
    }


   public static String removeAllTags(String cData)
   {
   	int iStartOfTag;
   	int iEndOfTag;
	iStartOfTag = cData.indexOf("<");
	if (iStartOfTag == -1) return cData;

	iEndOfTag = cData.indexOf(">");   	
   	
   	String cFirstPart = cData.substring(0, iStartOfTag);
   	
   	String cLastPart = cData.substring(iEndOfTag + 1);

	//Exit condition for recursive loop
	int iTestCondition = cData.indexOf("<");
	if (iTestCondition == -1)
		return cFirstPart + cLastPart;		
	else
		return removeAllTags(cFirstPart + cLastPart);	
	

	//return c+d;

	
   }

}