/*
 * WebNews.java - Retrives news from the web.
 * Copyright (C) 2000 Balaji Srinivasan
 * sbalaji@email.com
 * http://www.sbalaji.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


import java.util.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class WebNews extends HttpServlet
{

	//Local Path
	//static String cFilePath = "D:/orion/default-web-app/";

	//WebAppCabaret Path
	//static String cFilePath = "d:/else/servers/balaji/balaji/";

//	static String cFilePath = "d:/wac/contexts/balaji/balaji/";
//	static String cFilePath = "";


//	public WebNews()
//	{
//		cFilePath = getServletContext().getRealPath("/");
//		System.out.println(cFilePath);
//	}


	public static String getTimesOfIndiaHeadlines()
	{
		//String cData = Utility.getRemotePageData("http://developer:8010/testintra/toi.htm");
		//String cData = Utility.getRemotePageData("http://www.timesofindia.com/today/updates.htm");
		String cData = Utility.getRemotePageData("http://localhost/TOI.htm");

		if (cData.equals("")) return "";

		cData = Utility.getTaggedData(cData,"<!--main (middle pannel)news section starts-->", "<!--main (middle pannel)news section ends-->");

		cData = Utility.getTaggedData(cData,"<table width=365>", "</table>");

		//By now we have the data in rows + the links as header. Now get rid of the top links.

		String cReturnData = "";
		String cRowData;
		int i=0;
		while (!((cRowData = Utility.getTaggedDataFromBegin(cData, "<table width=100% border=0 cellpadding=0 cellspacing=0>", "</table>", "<table", i)).equals("")))
		{
			String cTopic = Utility.getTaggedData(cRowData, "<font face=verdana size=4 color=#3333CC><b>", "</b></font>");
			cReturnData += "<br><h2>" + cTopic + "</h2><br>";
			int j=0;
			String cSubRowData;
			while (!((cSubRowData = Utility.getTaggedDataFromBegin(cRowData, "<td width=100%>", "</td>", "<td", j)).equals("")))
			{
				String cHeadline = Utility.getTaggedData(cSubRowData, "<b>", "</b>");
				//Remove any pix
				String cRemainingData;
				StringBuffer sbRemainingData = new StringBuffer();
				Utility.getTaggedData(cSubRowData, "<table", "</table>", sbRemainingData);
				cRemainingData = sbRemainingData.toString();
				//Pix removed

				String cURL = Utility.getTaggedData(cRemainingData, "<a href=\"", "\" target=\"_top\"");

				String cDetails = Utility.getTaggedData(cRemainingData, "</a><br>", "<br><img src");

				cReturnData += "<a href=http://www.timesofindia.com/today/" + cURL +  ">";

				cReturnData += "<h3>" + cHeadline + "</h3><br>";

				cReturnData += "</a>";

				cReturnData += "<p>" + cDetails + "</p>";

				j++;
			}
			i++;
		}
		return cReturnData;
	}

	public static String writeTimesOfIndiaHeadlines(String cFileName)
	{
		String cNews = WebNews.getTimesOfIndiaHeadlines();
		if (cNews.equals(""))
		{
			//Server is probably down, so DON'T overwrite the cached file.
		}
		else
		{

			Date d = new Date();

			String cPrefix = "", cSuffix = "" ;

			cPrefix += "<p align=right><font size=1 face=Verdana>";
			cPrefix += "News Last Updated on: " + d.toString();
			cPrefix += "</font></p>";


			cSuffix += "<p align=right><font size=1 face=Verdana>";
			cSuffix += "Courtesy Times Of India";
			cSuffix += "</font></p>";

			cNews = "<html><body>" + cPrefix + cNews + cSuffix + "</body></html>";


			try
			{
				
				
				//Update Cache
				FileOutputStream fos = new FileOutputStream(cFileName);
				byte cNewsInBytes [] = cNews.getBytes();
				fos.write(cNewsInBytes);
				fos.close();


				System.out.println("TOI Cache updated @ " + d.toString());
			}
			catch(Exception ex)
			{
				System.out.println(ex);
				return "";
			}

		}
		return cNews;
	}


	public static String getTimesOfIndiaHeadlinesXML()
	{
		//String cData = Utility.getRemotePageData("http://developer:8010/testintra/toi.htm");
		//String cData = Utility.getRemotePageData("http://www.timesofindia.com/today/updates.htm");
		String cData = Utility.getRemotePageData("http://localhost/TOI.htm");

		if (cData.equals("")) return "";

		cData = Utility.getTaggedData(cData,"<!--main (middle pannel)news section starts-->", "<!--main (middle pannel)news section ends-->");

		cData = Utility.getTaggedData(cData,"<table width=365>", "</table>");

		//By now we have the data in rows + the links as header. Now get rid of the top links.


		String cReturnData = "<story>\n";

		String cRowData;
		int i=0;
		while (!((cRowData = Utility.getTaggedDataFromBegin(cData, "<table width=100% border=0 cellpadding=0 cellspacing=0>", "</table>", "<table", i)).equals("")))
		{


			String cTopic = Utility.getTaggedData(cRowData, "<font face=verdana size=4 color=#3333CC><b>", "</b></font>");

			cReturnData += " <topic>" + cTopic + "</topic>\n";

			int j=0;
			String cSubRowData;

			while (!((cSubRowData = Utility.getTaggedDataFromBegin(cRowData, "<td width=100%>", "</td>", "<td", j)).equals("")))
			{

				String cHeadline = Utility.getTaggedData(cSubRowData, "<b>", "</b>");

				//Remove any pix

				String cRemainingData;
				StringBuffer sbRemainingData = new StringBuffer();

				Utility.getTaggedData(cSubRowData, "<table", "</table>", sbRemainingData);

				cRemainingData = sbRemainingData.toString();

				//Pix removed

				String cURL = Utility.getTaggedData(cRemainingData, "<a href=\"", "\" target=\"_top\"");
				cURL = "http://www.timesofindia.com/today/" + cURL;

				String cDetails = Utility.getTaggedData(cRemainingData, "</a><br>", "<br><img src");
				cDetails = Utility.removeAllTags(cDetails);


				cReturnData += "  <headline>" + cHeadline + "</headline>\n";
				
				cReturnData += "   <url>" + cURL +  "</url>\n";

				cReturnData += "   <paragraph>" + cDetails + "</paragraph>\n";

				j++;
			}


			i++;
		}

		cReturnData += "</story>\n";
		return cReturnData;
	}



	public static String writeTimesOfIndiaHeadlinesXML(String cFileName)
	{
		String cNews = WebNews.getTimesOfIndiaHeadlinesXML();
		if (cNews.equals(""))
		{
			//Server is probably down, so DON'T overwrite the cached file.
		}
		else
		{

			Date d = new Date();

			String cPrefix = "", cSuffix = "" ;

			cPrefix += "<?xml version=\"1.0\"?>\n";
			cPrefix += "<?xml-stylesheet href=\"news.xsl\" type=\"text/xsl\"?>\n";
			cPrefix += "<?cocoon-process type=\"xslt\"?>\n";

			cPrefix += "<!DOCTYPE story [\n";
			cPrefix += " <!ELEMENT story (headline?, content)>\n";
			cPrefix += " <!ELEMENT headline (#PCDATA)>\n";
			cPrefix += " <!ELEMENT content (paragraph+)>\n";
			cPrefix += " <!ELEMENT paragraph (#PCDATA)>\n";								
			cPrefix += " ]>\n";	



//			cSuffix += "<p align=right><font size=1 face=Verdana>";
//			cSuffix += "Courtesy Times Of India";
//			cSuffix += "</font></p>";

			cNews = cPrefix + cNews + cSuffix;


			try
			{
				//Update Cache
				FileOutputStream fos = new FileOutputStream(cFileName);
				byte cNewsInBytes [] = cNews.getBytes();
				fos.write(cNewsInBytes);
				fos.close();


				System.out.println("TOI Cache updated @ " + d.toString());
			}
			catch(Exception ex)
			{
				System.out.println(ex);
				return "";
			}

		}
		return cNews;
	}


	//This method is for testing only
	public void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
	{
		String cFilePath = getServletContext().getRealPath("/");
		System.out.println(cFilePath);

		res.setContentType("text/html");
		ServletOutputStream out = res.getOutputStream();
		String s = writeTimesOfIndiaHeadlinesXML(cFilePath + "timesofindia.xml");
		out.println("Hello");
	}


}